package edu.rochester.cs.quagents3.aux;

import java.io.File;

import javax.sound.sampled.*;

public class AudioInput{
	private AudioFormat af;
	private TargetDataLine linein;
	private final String filename; //not including extension
	
	public AudioInput(String filename){
		this.filename = filename;
		captureAudio();
	}
	
	private void captureAudio(){
		af = getAudioFormat();
		DataLine.Info info = new DataLine.Info(TargetDataLine.class,af);
		try{
			linein = (TargetDataLine) AudioSystem.getLine(info);
			new CaptureThread().start();
		} catch(Exception e1){e1.printStackTrace(); System.exit(-1);}
		
	}
	
	//from developer.com tutorial
	private AudioFormat getAudioFormat(){
		float sampleRate = 22050F;
	    //8000,11025,16000,22050,44100
	    int sampleSizeInBits = 16;
	    //8,16
	    int channels = 1;
	    //1,2
	    boolean signed = true;
	    //true,false
	    boolean bigEndian = false;
	    //true,false
	    return new AudioFormat(sampleRate,
	                           sampleSizeInBits,
	                           channels,
	                           signed,
	                           bigEndian);
	}
	
	public void terminate(){
		linein.stop();
		linein.close();
	}
	
	class CaptureThread extends Thread{
		public final AudioFileFormat.Type filetype = AudioFileFormat.Type.AIFF;
		public final File audiofile = new File(filename + ".aif");
		public void run(){
			try{
			linein.open();
			linein.start();
			AudioSystem.write(new AudioInputStream(linein), filetype, audiofile);
			} catch(Exception e1){e1.printStackTrace();}
		}
	}
}
