package edu.rochester.cs.quagents3.client;

public class AbstractWumpusSolver {
	public final int right = 0;
	public final int up = 90;
	public final int left = 180;
	public final int down = 270;
	public final int roomSize = 192;
	public int facing = right, pos_x = 0, pos_y = 0;
	public int dim_x, dim_y;
	
	public boolean move(Client agent) {
		switch (facing) {
		case up:
			if (pos_y == dim_y - 1) {
				System.out.println("Bump wall");
				return false;
			}
			pos_y++; break;
    	case down:
    		if (pos_y == 0) {
				System.out.println("Bump wall");
				return false;
			}
    		pos_y--; break;
    	case left:
    		if (pos_x == 0) {
				System.out.println("Bump wall");
				return false;
			}
    		pos_x--; break;
    	case right:
    		if (pos_x == dim_x - 1) {
				System.out.println("Bump wall");
				return false;
			}
    		pos_x++; break;
		}
		
		agent.execute(new MoveBy(0, roomSize, 0.2, 0));
		return true;
	}
	
	public void faceDirection(Client agent, char dir) {
		switch (dir) {
		case 'u':
			agent.execute(new Rotate(up - facing));
			facing = up;
			break;
		case 'd':
			agent.execute(new Rotate(down - facing));
			facing = down;
			break;
		case 'l': 
			agent.execute(new Rotate(left - facing));
			facing = left;
			break;
		case 'r':
			agent.execute(new Rotate(right - facing));
			facing = right;
			break;
		}
	}
	
	public Radar sense(Client agent) {
		Radar sensor = new Radar(roomSize/2);
		agent.execute(sensor);
		return sensor;
	}
}
