package edu.rochester.cs.quagents3.client;

import java.io.IOException;
import java.util.*;
/**
 * @deprecated
 */
public class Agent{

	Client bot;
	//State s;
	
	//make these immutable?
	final Set<CommandType> action_set;
	final Set<CommandType> sensor_set;
	
	
	//list of currently attached sensors
	//may be singular or periodic
	private List<Command> sensors;
	
	public Agent(Set<CommandType> actions, Set<CommandType> sensors, String ip){
		try{bot = new Client(ip);}
		catch(Exception e1){System.err.println("Connection error: Please specify a valid Quagents3 Server IP");}
		this.action_set = actions;
		this.sensor_set = sensors;
		this.sensors = Collections.synchronizedList(new Vector<Command>());
	}
	
	//blocking
	public void execute(Command com){
		if(validateActionCommandType(com.whatAmI()))
			bot.execute(com);
		else
			System.err.println("error: Command of type \""+com.whatAmI()+"\" is not an element of Action Set");
	}
	
	//nonblocking
	public void start(Command com){
		if(validateActionCommandType(com.whatAmI()))
			bot.start(com);
		else
			System.err.println("error: Command of type \""+com.whatAmI()+"\" is not an element of Action Set");
	}
	

	public void addSensor(Command com){
		if(validateSensorCommandType(com.whatAmI()))
			sensors.add(com);
		bot.start(com);
	}
	
	public void terminate(){
		bot.terminate();
	}
	
	//updates all sensors
	public void update(){
		for(int i=0; i<sensors.size(); i++){
			sensors.get(i).update();
		}
	}
	
	public void ready(){
		try {bot.ready();} 
		catch (IOException e) {e.printStackTrace();}
	}
	
	public void setInitialPosition(double x, double y, double z){
		try {bot.initialPosition(x, y, z);} 
		catch (IOException e) {e.printStackTrace();}
	}
	
	public void setName(String name){
		try{bot.name(name);}
		catch(IOException e){e.printStackTrace();}
	}
	
	public void addEventListener(QEventListener q){
		bot.addEventListener(q);
	}
	
	public void addEventListener(CommandTerminationListener ctl){
		bot.addEventListener(ctl);
	}
	
	//validation commands
	private boolean validateActionCommandType(CommandType comtype){return action_set.contains(comtype);}
	private boolean validateSensorCommandType(CommandType comtype){return sensor_set.contains(comtype);}
}
