package edu.rochester.cs.quagents3.client;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import edu.rochester.cs.quagents3.audio.*;

public class CTFPlayer extends JPanel{
	Client bot;
	CurrentLocation gps;
	Facing facing;
	public static final int DISCRETE_STEP_SIZE = 20;
	private static final int WIDTH = 600;
	private static final int HEIGHT = 400;
	private static int NameID = 1;
	public static final int GPS_PERIOD = 100;
	File logfile;
	Writer logfilewriter;
	AudioInput audio;
	private JButton startButton, stopButton;
	private JLabel reclabel;
	
	public CTFPlayer(String ip, String logfilename) throws IOException{
		/*try {bot = new Client(ip);} 
		catch (Exception e){System.err.println("Connection error: Please specify a valid Quagents3 server address");}
		logfile = new File(logfilename +".dat");
		if(!logfile.isFile())
			logfile.createNewFile();
		else{
			logfile.delete();
			logfile.createNewFile();
		}
		logfilewriter = new FileWriter(logfile);
		this.addKeyListener(new CTFKeyListener());
		this.setFocusable(true);
		this.setPreferredSize(new Dimension(WIDTH,HEIGHT));
		this.setBackground(Color.white);
		audio = new AudioInput(logfilename);
		gps = new CurrentLocation(priority_t.NOW,GPS_PERIOD);
		facing = new Facing(priority_t.NOW, GPS_PERIOD);
		startButton = new JButton("Start");
		startButton.setEnabled(true);
		startButton.setForeground(Color.green);
		startButton.setVisible(true);
		stopButton = new JButton("Stop");
		stopButton.setEnabled(false);
		stopButton.setForeground(Color.red);
		stopButton.setVisible(true);
		//stopButton.setSize(new Dimension(200,50));
		reclabel = new JLabel();
		bot.addEventListener(new GPSListener());
		startButton.addActionListener(new StartListener());
		stopButton.addActionListener(new StopListener());
		this.add(startButton);
		try {bot.name("Player" + NameID++); bot.ready();} 
		catch (IOException e) {e.printStackTrace();}*/
	}
	
	/**
	 * Starts recording data and audio. Some users may want this out of the constructor.
	 */
	public void start(){
		bot.start(facing);
		bot.execute(gps);
		//audio.start();
	}
	/**
	 * Stops recording data and audio.
	 */
	public void stop(){
		audio.stop();
		bot.stop(gps);
	}
	
	/**
	 * Closes all readers and calls bot's terminate() func.
	 */
	public void terminate(){
		stop();
		audio.terminate();
		bot.terminate();
	}

	
	private class CTFKeyListener implements KeyListener{		
		public void keyPressed(KeyEvent e) {
			switch(e.getKeyCode()){
			case KeyEvent.VK_UP:
			case KeyEvent.VK_W:
				bot.moveBy(3*DISCRETE_STEP_SIZE, priority_t.REPLACE);
				break;
			case KeyEvent.VK_DOWN:
			case KeyEvent.VK_S:
				bot.moveBy(180, 3*DISCRETE_STEP_SIZE, Client.DEFAULTSPEED,priority_t.REPLACE);
				break;
			case KeyEvent.VK_A:
				bot.moveBy(90, 3*DISCRETE_STEP_SIZE, Client.DEFAULTSPEED, priority_t.REPLACE);
				break;
			case KeyEvent.VK_D:
				bot.moveBy(270,3*DISCRETE_STEP_SIZE,Client.DEFAULTSPEED, priority_t.REPLACE);
				break;
			case KeyEvent.VK_RIGHT:
				bot.rotate(-1*DISCRETE_STEP_SIZE, priority_t.NOW);
				break;
			case KeyEvent.VK_LEFT:
				bot.rotate(DISCRETE_STEP_SIZE, priority_t.NOW);
				break;
			case KeyEvent.VK_SPACE:
				bot.jump(priority_t.REPLACE);
				break;
			}
		}

		public void keyReleased(KeyEvent e) {
			// TODO Auto-generated method stub
			
		}

		public void keyTyped(KeyEvent e) {
			// TODO Auto-generated method stub
		}	
	}
	
	public void paintComponent(Graphics g){
		double[] loc = gps.getCurrentLocation();
		g.setColor(Color.green);
		g.clearRect(0, 0, WIDTH, HEIGHT);
		g.fillOval((int)loc[CurrentLocation.X], -1*(int) loc[CurrentLocation.Y], 20, 20);
		g.setColor(Color.yellow);
		g.fillArc((int)loc[CurrentLocation.X]-30, -1*(int)loc[CurrentLocation.Y]-30, 80, 80, ((int) (facing.getViewDirection()[Facing.YAW]))-60+34, 60);
	}
	
	private class GPSListener implements CommandTerminationListener{
		public void commandTerminated(Command com) {
			switch(com.whatAmI()){
			case CURRENTLOCATION:
				/*
				System.out.println("Location recieved. Updating logfile."); System.out.flush();
				double[] loc = gps.getCurrentLocation();
			 	try{
				logfilewriter.write("X:"+loc[CurrentLocation.X] + "\tY:"+loc[CurrentLocation.Y]+ "\tZ:"+loc[CurrentLocation.Z]+"\tTime:"+System.currentTimeMillis()+"\n");
				logfilewriter.flush();
				} catch(IOException e){e.printStackTrace();}
				*/
				repaint();
				break;
			case FACING:
				repaint();
				break;
			}
		}	
	}

	
	private class StartListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			startButton.setEnabled(false);
			stopButton.setEnabled(true);
			startButton.setVisible(false);
			start();
			reclabel.setText("Recording...");
		}		
	}
	
	private class StopListener implements ActionListener{
		public void actionPerformed(ActionEvent e){
			startButton.setEnabled(true);
			stopButton.setEnabled(false);
			reclabel.setText("Paused");
			stop();
		}
	}
}
