package edu.rochester.cs.quagents3.client;

import java.awt.event.*;

import javax.swing.*;

public class CameraQuagent extends JFrame {
	GOD director;
	Client camerabot;
	public static final int DISCRETE_STEP_SIZE = 10;
	private JButton depthButton, imageButton;
	private JPanel panel;
	
	public CameraQuagent(String ip) {
		try{director = new GOD("127.0.0.1");}
		catch(Exception e1){}
		try {camerabot = new Client(ip); 
		camerabot.name("Camera");
		camerabot.botfile("tony");
		camerabot.ready();
		}
		catch (Exception e1) {System.err.println("Please specify a valid Quagents3 server IP address.");}
		director.execute(new FollowViewpoint(camerabot.getQuagentID()));
		depthButton = new JButton("Depth");
		depthButton.setActionCommand("depth");
		depthButton.addActionListener(new ButtonListener());
		depthButton.setFocusable(false);
		imageButton = new JButton("Image");
		imageButton.setActionCommand("image");
		imageButton.addActionListener(new ButtonListener());
		imageButton.setFocusable(false);
		panel = new JPanel();
		panel.add(depthButton);
		panel.add(imageButton);
		panel.addKeyListener(new CameraKeyListener());
		panel.setFocusable(true);
		this.add(panel);
		this.setSize(270, 70);
		this.setTitle("Robotic Imaging System");
		this.setVisible(true);
	}
	
	private class CameraKeyListener implements KeyListener{		
		public void keyPressed(KeyEvent e) {
			switch(e.getKeyCode()){
			case KeyEvent.VK_W:
				camerabot.moveBy(6*DISCRETE_STEP_SIZE, priority_t.REPLACE);
				break;
			case KeyEvent.VK_S:
				camerabot.moveBy(180, 6*DISCRETE_STEP_SIZE, Client.DEFAULTSPEED,priority_t.REPLACE);
				break;
			case KeyEvent.VK_A:
				camerabot.moveBy(90, 6*DISCRETE_STEP_SIZE, Client.DEFAULTSPEED, priority_t.REPLACE);
				break;
			case KeyEvent.VK_D:
				camerabot.moveBy(270,6*DISCRETE_STEP_SIZE,Client.DEFAULTSPEED, priority_t.REPLACE);
				break;
			case KeyEvent.VK_UP:
				camerabot.rotate(0, -1*DISCRETE_STEP_SIZE, priority_t.NOW);
				break;
			case KeyEvent.VK_DOWN:
				camerabot.rotate(0, DISCRETE_STEP_SIZE, priority_t.NOW);
				break;
			case KeyEvent.VK_RIGHT:
				camerabot.rotate(-1*DISCRETE_STEP_SIZE, priority_t.NOW);
				break;
			case KeyEvent.VK_LEFT:
				camerabot.rotate(DISCRETE_STEP_SIZE, priority_t.NOW);
				break;
			case KeyEvent.VK_SPACE:
				camerabot.jump(priority_t.REPLACE);
				break;
			case KeyEvent.VK_1:
				camerabot.execute(new DepthViewpoint());
				break;
			case KeyEvent.VK_2:
				camerabot.execute(new ImageViewpoint());
				break;
			}
			
		}
		public void keyTyped(KeyEvent e) {
			// TODO Auto-generated method stub
			
		}
		public void keyReleased(KeyEvent e) {
			// TODO Auto-generated method stub
			
		}
	}
	
	private class ButtonListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			if ("depth".equals(e.getActionCommand())) {
				camerabot.execute(new DepthViewpoint());
				
			}
			if ("image".equals(e.getActionCommand())) {
				camerabot.execute(new ImageViewpoint());
			}
		}		
	}
}
