package edu.rochester.cs.quagents3.client;
import java.io.Writer;
import java.util.Scanner;

public class CurrentAmmo extends ProtocolZero{
	private static final String opcode = "mc";
	
	private final weapon wep;
	public static final int DEFAULTAMMO = -1;
	private int ammo = DEFAULTAMMO;
	
	public CurrentAmmo(weapon wep, priority_t priority){
		super(true,CommandType.CURRENTAMMO,priority);
		this.wep = wep;
	}
	public CurrentAmmo(weapon wep){
		super(true,CommandType.CURRENTAMMO);
		this.wep = wep;
	}
	public CurrentAmmo(weapon wep, priority_t priority,long period){
		super(true,CommandType.CURRENTAMMO,period,priority);
		this.wep = wep;
	}
	public CurrentAmmo(weapon wep,long period){
		super(true,CommandType.CURRENTAMMO,period);
		this.wep = wep;
	}
	public CurrentAmmo(weapon wep, priority_t priority,
			long period,long delay){
		super(true,CommandType.CURRENTAMMO,period,delay,priority);
		this.wep = wep;
	}
	public CurrentAmmo(weapon wep,
			long period,long delay){
		super(true,CommandType.CURRENTAMMO,period,delay);
		this.wep = wep;
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " "  + opcode + " " + id + " " + 
		SwitchWeapon.convertWeapon(wep);		
	}
	
	/**
	 * Returns the ammunition for <i>wep</i>, if wep is valid.
	 * @return If <i>wep</i> is valid, ammunition remaining for <i>wep</i>. <br/>
	 * Else, returns -1.
	 */
	public int getAmmo(){
		if(this.ecode.equals("INVALID_WEAPON")) return -1;
		else return ammo;
	}
	
	/**
	 * Allows access to parameter data.
	 * @return Weapon query sent to server.
	 */
	public weapon getWeapon(){
		return wep;
	}

	public void setData(String params) {
		datastring = params;
		paramscan = new Scanner(params);
		ammo = paramscan.nextInt();
	}
}
