package edu.rochester.cs.quagents3.client;
import java.io.Writer;
import java.util.Scanner;

/**
 * Class which represents a CurrentArmor query.
 */
public class CurrentArmor extends ProtocolZero{
	private static final String opcode = "ac";
	
	private int currentarmor;
	
	public CurrentArmor(priority_t priority){
		super(true,CommandType.CURRENTARMOR,priority);
	}
	public CurrentArmor(){
		super(true,CommandType.CURRENTARMOR);
	}
	public CurrentArmor(priority_t priority,
			long period){
		super(true,CommandType.CURRENTARMOR,period,priority);
	}
	public CurrentArmor(long period){
		super(true,CommandType.CURRENTARMOR,period);
	}
	public CurrentArmor(priority_t priority,
			long period,long delay){
		super(true,CommandType.CURRENTARMOR,period,delay,priority);
	}
	public CurrentArmor(long period,long delay){
		super(true,CommandType.CURRENTARMOR,period,delay);
	}
 
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id;
	}
	/**
	 * Returns Quagent's current armor value.
	 * @return Quagent's current armor value.
	 */
	public int getCurrentArmor(){
		return currentarmor;
	}
	
	@Override
	public void setData(String params) {
		datastring = params;
		paramscan = new Scanner(params);
		currentarmor = paramscan.nextInt();
	}
}
