package edu.rochester.cs.quagents3.client;
import java.util.Scanner;

/**
 * Class which represents a CurrentHealth query.
 */
public class CurrentHealth extends ProtocolZero{
	private static final String opcode = "hc";
	
	private int currenthealth;
	
	public CurrentHealth(priority_t priority){
		super(true,CommandType.CURRENTHEALTH,priority);
	}
	public CurrentHealth(){
		super(true,CommandType.CURRENTHEALTH);
	}
	public CurrentHealth(priority_t priority,
			long period){
		super(true,CommandType.CURRENTHEALTH,period,priority);
	}
	public CurrentHealth(long period){
		super(true,CommandType.CURRENTHEALTH,period);
	}
	public CurrentHealth(priority_t priority,
			long period,long delay){
		super(true,CommandType.CURRENTHEALTH,period,delay,priority);
	}
	public CurrentHealth(long period,long delay){
		super(true,CommandType.CURRENTHEALTH,period,delay);
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id;
	}
	
	/**
	 * Returns Quagent's current health.
	 * @return Quagent's current health.
	 */
	public int getCurrentHealth(){
		return currenthealth;
	}
	
	@Override
	public void setData(String params) {
		datastring = params;
		paramscan = new Scanner(params);
		currenthealth = paramscan.nextInt();
	}
}
