package edu.rochester.cs.quagents3.client;
import java.io.Writer;
import java.util.Scanner;

/**
 * Class which represents a CurrentLocation query.
 * @usage May be used (perhaps alongside the scheduler) as a GPS.
 */
public class CurrentLocation extends ProtocolZero{
	private static final String opcode = "lc";
	
	//global index ref
	public static final int X = 0;
	public static final int Y = 1;
	public static final int Z = 2;
	private double[] coords; //(x,y,z)
	
	public CurrentLocation(priority_t priority){
		super(true,CommandType.CURRENTLOCATION,priority);
		coords = new double[3];
	}
	public CurrentLocation(){
		super(true,CommandType.CURRENTLOCATION);
		coords = new double[3];
	}
	public CurrentLocation(priority_t priority,long period){
		super(true,CommandType.CURRENTLOCATION,period,priority);
		coords = new double[3];
	}
	public CurrentLocation(long period){
		super(true,CommandType.CURRENTLOCATION,period);
		coords = new double[3];
	}
	public CurrentLocation(priority_t priority,long period,long delay){
		super(true,CommandType.CURRENTLOCATION,period,delay,priority);
		coords = new double[3];
	}
	public CurrentLocation(long period,long delay){
		super(true,CommandType.CURRENTLOCATION,period,delay);
		coords = new double[3];
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id;
	}
	
	/**
	 * Returns Quagent's current location.
	 * @return Quagent's current location.
	 */
	public double[] getCurrentLocation(){
		return coords;
	}

	public void setData(String params) {
		datastring = params;
		paramscan = new Scanner(params);
		coords[X] = paramscan.nextDouble();
		coords[Y] = paramscan.nextDouble();
		coords[Z] = paramscan.nextDouble();
	}
}
