package edu.rochester.cs.quagents3.client;
/**
 * GOD command.
 */
public class Drop extends ProtocolZero{
	private static final String opcode = "dr";
	
	public static final int TREASURE = 0;
	public static final int GOLD = 1;
	
	private final int item;
	private final int quantity;
	private final double[] location;
	
	private static final int X = 0;
	private static final int Y = 1;
	private static final int Z = 2;
	
	public Drop(int item, int quantity, double x, double y, double z){
		super(false,CommandType.DROP);
		this.item = item;
		this.quantity = quantity;
		location = new double[3];
		location[X] = x; location[Y] = y; location[Z] = z;
	}
	
	public int getItem(){
		return item;
	}
	
	public int getQuantity(){
		return quantity;
	}
	
	public double getX(){
		return location[X];
	}
	
	public double getY(){
		return location[Y];
	}
	
	public double getZ(){
		return location[Z];
	}
	
	public double[] getLocation(){
		return location;
	}

	@Override
	public void setData(String params) {
		System.err.println("error: Drop does not facilitate data response");
	}

	@Override
	protected void setOp() {
		op = opcode + " " + id + " " + item + " " + quantity + " " +
		location[X] + " " + location[Y] + " " + location[Z];
	}
}
