package edu.rochester.cs.quagents3.client;
import java.io.Writer;
import java.util.Scanner;

/**
 * Class which represents a Facing query.
 */
public class Facing extends ProtocolZero{
	private static final String opcode = "fc";
	
	//global index reference
	public static final int YAW = 0;
	public static final int PITCH = 1;
	public static final int ROLL = 2;
	private double[] viewangle;
	
	public Facing(priority_t priority){
		super(true,CommandType.FACING,priority);
		viewangle = new double[3];
	}
	public Facing(){
		super(true,CommandType.FACING);
		viewangle = new double[3];
	}
	public Facing(priority_t priority,long period){
		super(true,CommandType.FACING,period,priority);
		viewangle = new double[3];
	}
	public Facing(long period){
		super(true,CommandType.FACING,period);
		viewangle = new double[3];
	}
	public Facing(priority_t priority,long period,long delay){
		super(true,CommandType.FACING,period,delay,priority);
		viewangle = new double[3];
	}
	public Facing(long period,long delay){
		super(true,CommandType.FACING,period,delay);
		viewangle = new double[3];
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id;
	}
	
	/**
	 * Allows access to the Quagent's current direction vector.
	 * @return Quagent's current facing.
	 */
	public double[] getViewDirection(){
		return viewangle;
	}

	public void setData(String params) {
		datastring = params;
		paramscan = new Scanner(params);
		viewangle[YAW] = paramscan.nextDouble();
		viewangle[PITCH] = paramscan.nextDouble();
		viewangle[ROLL] = paramscan.nextDouble();
	}
	
}
