package edu.rochester.cs.quagents3.client;

import java.util.Scanner;

public class FindDistance extends ProtocolZero{
	private static final String opcode = "fd";
	
	public static final int X = 0;
	public static final int Y = 1;
	public static final int Z = 2;
	
	private final double[] point1; private final double[] point2;
	
	private double distance;
	
	public FindDistance(double[] point1, double[] point2){
		super(true,CommandType.FINDDISTANCE);
		if(point1.length!=3 || point2.length!=3){
			System.err.println("error: FindDistance must be supplied an array of [x,y,z].");
			System.exit(-1); //we need better Command error handling...
		}
		this.point1 = point1;
		this.point2 = point2;
	}
	
	public FindDistance(double x1, double y1, double z1, double x2, double y2, double z2){
		super(true,CommandType.FINDDISTANCE);
		point1 = new double[3]; point2 = new double[3];
		point1[X] = x1; point1[Y] = y1; point1[Z] = z1;
		point2[X] = x2; point2[Y] = y2; point2[Z] = z2;
	}
	
	public double[] getPoint1(){
		return point1;
	}
	
	public double[] getPoint2(){
		return point2;
	}
	
	public double getDistance(){
		return distance;
	}

	public void setData(String params) {
		datastring = params;
		paramscan = new Scanner(params);
		distance = paramscan.nextDouble();
	}

	@Override
	protected void setOp() {
		op = opcode + " " + id + " " + point1[X] + " " + point1[Y] + " " + point1[Z] + " " 
		+ point2[X] + " "  + point2[Y] + " " + point2[Z];
	}
}
