package edu.rochester.cs.quagents3.client;
/**
 * Class which represents a FireWeapon command.
 * @usage Although this class may not seem useful to keep track of, it might be useful to store
 * and repeatedly call run() whenever a shot is desired. 
 */
public class FireWeapon extends ProtocolZero{
	private static final String opcode = "fw";
	
	public FireWeapon(priority_t priority){
		super(false,CommandType.FIREWEAPON,priority);
	}
	public FireWeapon(){
		super(false,CommandType.FIREWEAPON);
	}
	public FireWeapon(priority_t priority,
			long period){
		super(false,CommandType.FIREWEAPON,period,priority);
	}
	public FireWeapon(long period){
		super(false,CommandType.FIREWEAPON,period);
	}
	public FireWeapon(priority_t priority,
			long period,long delay){
		super(false,CommandType.FIREWEAPON,period,delay,priority);
	}
	public FireWeapon(long period,long delay){
		super(false,CommandType.FIREWEAPON,period,delay);
	}

	public void setData(String params) {
		System.err.println("error: FireWeapon does not facilitate data response");
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id;
	}
}
