package edu.rochester.cs.quagents3.client;

import java.util.Date;

/**
 * A GODEvent represents an event occurrence in the Quake world which relates to the
 * macroscopic game state.
 *
 */
public class GODEvent {
	public static int PLAYERJOIN = 0;
	public static int PLAYERDROP = 1;
	public static int PLAYERDIED = 2;
	private final int eventcode;
	private final int id;
	private final String name;
	private final Date timestamp;
	
	
	public GODEvent(int eventcode, int id, String name){
		this.eventcode = eventcode;
		this.id = id;
		this.name = name;
		timestamp = new Date();
	}
	
	public Date getTimestamp(){
		return timestamp;
	}
	
	//ms since 1970
	public long getTime(){
		return timestamp.getTime();
	}
	
	//not very useful...
	public int getEventType(){
		return eventcode;
	}
	
	/**
	 * Returns the ID of the player for whom the event is related.
	 */
	public int getID(){
		return id;
	}
	
	/**
	 * Returns the name of the player for whom the event is related.
	 */
	public String getName(){
		return name;
	}
}
