package edu.rochester.cs.quagents3.client;

public class GametypeAndMapControl extends ProtocolZero{
	private static final String opcode = "gm";
	public static int FREE_FOR_ALL = 0;
	public static int TOURNAMENT = 1;
	public static int TEAM_DEATHMATCH = 3;
	public static int CAPTURE_THE_FLAG = 4;
	
	private final int gametype;
	private final String map; //users need to be careful with this...
						  	  //maybe we should use an enum or load map list from file for validation?
	
	public GametypeAndMapControl(int gametype, String map){
		super(false,CommandType.GAMETYPEANDMAPCONTROL);
		this.gametype = gametype;
		this.map = map;
	}
	
	public GametypeAndMapControl(String map){
		super(false, CommandType.GAMETYPEANDMAPCONTROL);
		this.gametype = FREE_FOR_ALL; //we don't really care about gametype for quagents
		this.map = map;
	}
	
	public int getGametype(){
		return gametype;
	}
	
	public String getMap(){
		return map;
	}

	@Override
	public void setData(String params) {
		System.err.println("error: GametypeAndMapControl does not facilitate data response");
	}

	@Override
	protected void setOp() {
		op = opcode + " " + id + " " + gametype + " " + map;
	}
}
