package edu.rochester.cs.quagents3.client;

import java.awt.Dimension;
import java.awt.Panel;
import java.awt.image.*;
import java.util.Scanner;
import java.io.File;
import java.io.InputStream;

import javax.swing.JFrame;

public class ImageViewpoint extends ProtocolZero{
	private static final String opcode = "vc";
	public static final int BYTESPERPIXEL = 3;
	private static int pixnum = 0; //so we can have multiple filse
	
	private int width;
	private int height;
	private byte[] bytes;
	
	public ImageViewpoint(priority_t priority){
		super(true, CommandType.IMAGEVIEWPOINT, priority);
	}
	
	public ImageViewpoint(){
		super(true, CommandType.IMAGEVIEWPOINT);
	}
	
	public ImageViewpoint(long period){
		super(true, CommandType.IMAGEVIEWPOINT, period);
	}
	
	public ImageViewpoint(long period, priority_t priority){
		super(true, CommandType.IMAGEVIEWPOINT, period, priority);
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id;
	}
	
	public int getWidth(){
		return width;
	}
	
	public int getHeight(){
		return height;
	}
	
	public byte[] getEncodedBytestream(){
		return bytes;
	}
	
	public void setData(String params){} //not used - special case
	
	public void setData(int width, int height, byte[] bytes){
		this.width = width;
		this.height = height;
		this.bytes = bytes;
		QView2png();
	}
	
	private void QView2png(){ //from auxquagents file
		//so we don't overwrite old screenshots
		String fname;
		while(true){
			fname = "screenshots/imageviewpoint" + pixnum + ".png";
			File f = new File(fname);
			if(!f.exists())
				break;
			else
				pixnum++;
		}
	try{
	BufferedImage b=new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB);
	   WritableRaster wr=b.getRaster();
		System.out.println("SENT");
	    for(int i=0;i<height;i++){
	     for(int j=0;j<width;j++){
	      int[] color=new int[3];
	      color[0]=bytes[(i*width+j)*3+0];
	      color[1]=bytes[(i*width+j)*3+1];
	      color[2]=bytes[(i*width+j)*3+2];
	      wr.setPixel(j,height-i-1,color);
	     }
	    }
	   b.setData(wr);
	   System.out.println("Saving image...");
	   javax.imageio.ImageIO.write(b,"png",new java.io.File(fname));
	   draw(b, width, height);
	   System.out.println("File revision complete.");
	  }catch(Exception e){
	   System.out.println("Fatal Exception:");
	   e.printStackTrace();
	   System.out.println("abort");
	  }
	}
	
	public void draw(BufferedImage b, int width, int height) {
		JFrame frame = new JFrame("Image Viewpoint");
		Panel panel = new QImage(b);
		panel.setPreferredSize(new Dimension(width, height));
		frame.getContentPane().add(panel);
		frame.pack();
		frame.setVisible(true);
	}
}
