package edu.rochester.cs.quagents3.client;

import java.util.Scanner;

public class IsWithin extends ProtocolZero{
	private static final String opcode = "iw";
	
	public static final int X = 0;
	public static final int Y = 1;
	public static final int Z = 2;
	
	private final int entityid;
	private final double[] point1;
	private final double[] point2;
	
	private boolean iswithin;
	
	public IsWithin(int entityid, double x1, double y1, double z1, double x2, double y2, double z2){
		super(true,CommandType.ISWITHIN);
		this.entityid = entityid;
		point1 = new double[3]; point2 = new double[3];
		point1[X] = x1; point1[Y] = y1; point1[Z] = z1;
		point2[X] = x2; point2[Y] = y2; point2[Z] = z2;
	}
	
	public double[] getPoint1(){
		return point1;
	}
	
	public double[] getPoint2(){
		return point2;
	}
	
	public int getEntityID(){
		return entityid;
	}

	public boolean isWithin(){
		return iswithin;
	}
	
	public void setData(String params) {
		datastring = params;
		paramscan = new Scanner(params);
		String b = paramscan.next();
		if(b.equals("t"))
			iswithin = true;
		else if(b.equals("f"))
			iswithin = false;
		else
			System.err.println("protocol error: iswithin data response");
	}

	protected void setOp() {
		op = opcode + " " + id + " " + entityid + " " + point1[X] + " " + point1[Y] + " " + point1[Z] + " "
		+ point2[X] + " " + point2[Y] + " " + point2[Z];
	}
}
