package edu.rochester.cs.quagents3.client;

/**
 * Class which represents a Jump command.
 */
public class Jump extends ProtocolZero{
	private static final String opcode = "ju";
	
	//parameters
	private final double dir, speed;
	
	public Jump(double dir, double speed, priority_t priority){
		super(false,CommandType.JUMP,priority);
		this.dir = dir;
		this.speed = speed;
	}
	public Jump(double dir, double speed){
		super(false,CommandType.JUMP);
		this.dir = dir;
		this.speed = speed;
	}
	public Jump(double dir, double speed, priority_t priority,long period){
		super(false,CommandType.JUMP,period,priority);
		this.dir = dir;
		this.speed = speed;
	}
	public Jump(double dir, double speed,long period){
		super(false,CommandType.JUMP,period);
		this.dir = dir;
		this.speed = speed;
	}
	public Jump(double dir, double speed, priority_t priority,long period,long delay){
		super(false,CommandType.JUMP,period,delay,priority);
		this.dir = dir;
		this.speed = speed;
	}
	public Jump(double dir, double speed,long period,long delay){
		super(false,CommandType.JUMP,period,delay);
		this.dir = dir;
		this.speed = speed;
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id
		+ " " + dir + " " +speed;
	}
	
	@Override
	public void setData(String params) {
		System.err.println("error: Pause has no data response");
	}
	
	/**
	 * Allows access to parameter data.
	 * @return Direction of jump. 
	 */
	public double getDirection(){return dir;}
	
	/**
	 * Allows access to parameter data.
	 * @return Speed of jump. 
	 */
	public double getSpeed(){return speed;}
}
