package edu.rochester.cs.quagents3.client;
import java.util.Scanner;

/**
 * Class which represents a MaxArmor query.
 */
public class MaxArmor extends ProtocolZero{
	private static final String opcode = "am";
	private int maxarmor;
	
	public MaxArmor(priority_t priority){
		super(true,CommandType.MAXARMOR,priority);
	}
	public MaxArmor(){
		super(true,CommandType.MAXARMOR);
	}
	public MaxArmor(priority_t priority,long period){
		super(true,CommandType.MAXARMOR,period,priority);
	}
	public MaxArmor(long period){
		super(true,CommandType.MAXARMOR,period);
	}
	public MaxArmor(priority_t priority,long period,long delay){
		super(true,CommandType.MAXARMOR,period,delay,priority);
	}
	public MaxArmor(long period,long delay){
		super(true,CommandType.MAXARMOR,period,delay);
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id;
	}
	
	@Override
	public void setData(String params) {
		datastring = params;
		paramscan = new Scanner(params);
		maxarmor = paramscan.nextInt();
	}
	
	/**
	 * Returns Quagent's maximum possible armor value.
	 * @return Quagent's maximum possible armor value.
	 */
	public int getMaxArmor(){
		return maxarmor;
	}
}
