package edu.rochester.cs.quagents3.client;
import java.io.Writer;
import java.util.Scanner;

/**
 * Class which represents a MaxHealth query.
 */
public class MaxHealth extends ProtocolZero{
	private static final String opcode = "hm";
	private int maxhealth;
	
	public MaxHealth(priority_t priority){
		super(true,CommandType.MAXHEALTH,priority);
	}
	public MaxHealth(){
		super(true,CommandType.MAXHEALTH);
	}
	public MaxHealth(priority_t priority,long period){
		super(true,CommandType.MAXHEALTH,period,priority);
	}
	public MaxHealth(long period){
		super(true,CommandType.MAXHEALTH,period);
	}
	public MaxHealth(priority_t priority,long period,long delay){
		super(true,CommandType.MAXHEALTH,period,delay,priority);
	}
	public MaxHealth(long period,long delay){
		super(true,CommandType.MAXHEALTH,period,delay);
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id;
	}
	
	@Override
	public void setData(String params) {
		datastring = params;
		paramscan = new Scanner(params);
		maxhealth = paramscan.nextInt();
	}
	
	/**
	 * Returns Quagent's maximum possible health.
	 * @return Quagent's maximum possible health.
	 */
	public int getMaxHealth(){
		return maxhealth;
	}
}
