package edu.rochester.cs.quagents3.client;

/**
 * Class that represents a MoveForever command.
 */
public class MoveForever extends ProtocolZero{
	private static final String opcode = "mi";
	
	private final double dir, speed;
	private final int obstacles;
	
	public MoveForever(){
		super(false,CommandType.MOVEFOREVER);
		this.dir = 0;
		this.speed = Client.DEFAULTSPEED;
		this.obstacles = 0;
	}
	public MoveForever(double dir, double speed, int obstacles, priority_t priority){
		super(false,CommandType.MOVEFOREVER,priority);
		this.dir = dir;
		this.speed = speed;
		this.obstacles = obstacles;
	}
	public MoveForever(double dir, double speed, int obstacles){
		super(false,CommandType.MOVEFOREVER);
		this.dir = dir;
		this.speed = speed;
		this.obstacles = obstacles;
	}
	public MoveForever(double dir, double speed, int obstacles, priority_t priority,long period){
		super(false,CommandType.MOVEFOREVER,period,priority);
		this.dir = dir;
		this.speed = speed;
		this.obstacles = obstacles;
	}
	public MoveForever(double dir, double speed, int obstacles,long period){
		super(false,CommandType.MOVEFOREVER,period);
		this.dir = dir;
		this.speed = speed;
		this.obstacles = obstacles;
	}
	public MoveForever(double dir, double speed, int obstacles, priority_t priority,long period,long delay){
		super(false,CommandType.MOVEFOREVER,period,delay,priority);
		this.dir = dir;
		this.speed = speed;
		this.obstacles = obstacles;
	}
	public MoveForever(double dir, double speed, int obstacles,long period,long delay){
		super(false,CommandType.MOVEFOREVER,period,delay);
		this.dir = dir;
		this.speed = speed;
		this.obstacles = obstacles;
	}
	
	
	protected void setOp(){
		op = Client.convertPriority(priority)+ " " + opcode + " " + id+ " "+
		obstacles + " " + dir + " " + speed;
	}
	
	@Override
	public void setData(String params) {
		System.err.println("error: MoveForever has no data response");
	}
	
	/**
	 * Allows access to parameter data.
	 * @return Direction of movement. Degrees left of Quagent's original facing. 
	 */
	public double getDirection(){return dir;}
	
	/**
	 * Allows access to parameter data.
	 * @return Speed of movement. 
	 */
	public double getSpeed(){return speed;}
	
	/**
	 * Allows access to parameter data.
	 * @return Obstacles flag. 
	 */
	public int getObstacles(){return obstacles;}
}
