package edu.rochester.cs.quagents3.client;
import java.io.Writer;
import java.util.List;

/**
 * Class that represents a Pause CQM.
 */
public class Pause extends ProtocolZero{
	private static final String opcode = "pa";
	public Pause(priority_t priority){
		super(false,CommandType.PAUSE,priority);
	}
	public Pause(){
		super(false,CommandType.PAUSE);
	}
	public Pause(priority_t priority,long period){
		super(false,CommandType.PAUSE,period,priority);
	}
	public Pause(long period){
		super(false,CommandType.PAUSE,period);
	}
	public Pause(priority_t priority,long period,long delay){
		super(false,CommandType.PAUSE,period,delay,priority);
	}
	public Pause(long period,long delay){
		super(false,CommandType.PAUSE,period,delay);
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id;
	}
	
	@Override
	public void setData(String params) {
		System.err.println("error: Pause has no data response");
	}
}
