package edu.rochester.cs.quagents3.client;

public class PutDown extends ProtocolZero{
	private static final String opcode = "pd";
	
	private final int item;
	private final int quantity;
	
	
	public PutDown(int item, int quantity){
		super(false,CommandType.PUTDOWN);
		this.item = item;
		this.quantity = quantity;
	}
	
	public PutDown(int item, int quantity, long period){
		super(false,CommandType.PUTDOWN,period);
		this.item = item;
		this.quantity = quantity;
	}
	
	public PutDown(int item, int quantity, long period, priority_t priority){
		super(false,CommandType.PUTDOWN,period, priority);
		this.item = item;
		this.quantity = quantity;
	}
	
	public PutDown(int item, int quantity, priority_t priority){
		super(false,CommandType.PUTDOWN, priority);
		this.item = item;
		this.quantity = quantity;
	}
	
	public void setData(String params) {
		System.err.println("error: putdown does not facilitate a data response");
	}

	public int getItem(){
		return item;
	}
	
	public int getQuantity(){
		return quantity;
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id + " " 
		+ item + " " + quantity;
	}
}
