package edu.rochester.cs.quagents3.client;

/**
 * Simple compound function. The Quagent rotates to the left by the specified
 * rotational and azimuthal angle values, and fires its weapon.
 */
public class RotateFireWeapon extends ProtocolOne{
	private final Rotate rotate;
	private final FireWeapon fw;
	
	public RotateFireWeapon(double rot, double azi){
		super(CommandType.ROTATEFIREWEAPON);
		rotate = new Rotate(rot,azi);
		fw = new FireWeapon();
	}

	@Override
	public void update() {
		rotate.waitForTerminate();
		fw.waitForTerminate();
	}

	public boolean hasTerminated(){
		return (rotate.hasTerminated() && fw.hasTerminated());
	}
	
	@Override
	public void run() {
		rotate.run();
		fw.run();
	}
	
	public double getRotationalAngle(){
		return rotate.getRotationalAngle();
	}
	
	public double getAzimuthalAngle(){
		return rotate.getAzimuthalAngle();
	}

	@Override
	protected void addChildren() {
		children.add(rotate);
		children.add(rotate);
	}
}
