package edu.rochester.cs.quagents3.client;
import java.io.Writer;

/**
 * Class which represents a Say command.
 */
public class Say extends ProtocolZero{
	private static final String opcode = "sy";
	
	private final double volume;
	private final String msg;
	
	public Say(double volume, String msg, priority_t priority){
		super(false,CommandType.SAY,priority);
		this.volume = volume;
		this.msg = msg;
	}
	public Say(double volume, String msg){
		super(false,CommandType.SAY);
		this.volume = volume;
		this.msg = msg;
	}
	public Say(double volume, String msg, priority_t priority,long period){
		super(false,CommandType.SAY,period,priority);
		this.volume = volume;
		this.msg = msg;
	}
	public Say(double volume, String msg,long period){
		super(false,CommandType.SAY,period);
		this.volume = volume;
		this.msg = msg;
	}
	public Say(double volume, String msg, priority_t priority,long period,long delay){
		super(false,CommandType.SAY,period,delay,priority);
		this.volume = volume;
		this.msg = msg;
	}
	public Say(double volume, String msg,long period,long delay){
		super(false,CommandType.SAY,period,delay);
		this.volume = volume;
		this.msg = msg;
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " "  + opcode + " " + id + " " + volume + " " + msg;
	}

	public void setData(String params) {
		System.err.println("error: Say does not facilitate data response");
	}
	
	/**
	 * Allows access to parameter data.
	 * @return Volume of Say command.
	 */
	public double getVolume(){return volume;}
	
	/**
	 * Allows access to parameter data.
	 * @return Message transmitted for Say command.
	 */
	public String getMsg(){return msg;}
}
