package edu.rochester.cs.quagents3.client;

/**
 * SetArmor represents a GOD command which sets the armor of a specified
 * entity to a specified amount. 
 */
public class SetArmor extends ProtocolZero{
	private static final String opcode = "sa";
	public static final int ALLBOTS = -1;
	
	private final int qid;
	private final int newarmor;
	
	public SetArmor(int qid, int newarmor){
		super(false,CommandType.SETARMOR);
		this.qid = qid;
		this.newarmor = newarmor;
	}
	
	
	/**
	 * Sets all bots armor to <i>armor</i>
	 * @param newarmor New armor value for all Quagents to assume.
	 */
	public SetArmor(int newarmor){
		super(false,CommandType.SETARMOR);
		this.qid=ALLBOTS;
		this.newarmor = newarmor;
	}
	
	public void setData(String params){
		System.err.println("error: SetArmor does not facilitate data response");
	}
	
	protected void setOp(){
		op = opcode + " " + id + " " + qid + " " + newarmor;
	}
	
	public int getQID(){
		return qid;
	}
	
	public int getNewArmor(){
		return newarmor;
	}
}
