package edu.rochester.cs.quagents3.client;

/**
 * SetGravity is a GOD command which allows control over in-game gravity.
 */
public class SetGravity extends ProtocolZero{
	private static final String opcode = "sg";
	public static final double DEFAULTGRAVITY = 800;
	
	private final double gravity;
	
	public SetGravity(double gravity){
		super(false,CommandType.SETGRAVITY);
		this.gravity = gravity;
	}
	
	/**
	 * Resets gravity to DEFAULTGRAVITY
	 */
	public SetGravity(){
		super(false, CommandType.SETGRAVITY);
		this.gravity = DEFAULTGRAVITY;
	}
	
	public void setData(String params){
		System.err.println("error: SetGravity does not facilitate data response");
	}
	
	protected void setOp(){
		op = opcode + " " + id + " " + gravity;
	}
	
	public double getGravity(){
		return gravity;
	}
}
