package edu.rochester.cs.quagents3.client;

/**
 * SetHealth represents a GOD command which sets the health of a specified
 * entity to a specified amount. 
 */
public class SetHealth extends ProtocolZero{
	private static final String opcode = "sh";
	public static final int ALLBOTS = -1;
	
	private final int qid;
	private final int newhealth;
	
	public SetHealth(int qid, int newhealth){
		super(false,CommandType.SETHEALTH);
		this.qid = qid;
		this.newhealth = newhealth;
	}
	
	
	/**
	 * Sets all bots health to <i>newhealth</i>
	 * @param newhealth New health value for all Quagents to assume.
	 */
	public SetHealth(int newhealth){
		super(false,CommandType.SETHEALTH);
		this.qid=ALLBOTS;
		this.newhealth = newhealth;
	}
	
	public void setData(String params){
		System.err.println("error: SetHealth does not facilitate data response");
	}
	
	protected void setOp(){
		op = opcode + " " + id + " " + qid + " " + newhealth;
	}
	
	public int getQID(){
		return qid;
	}
	
	public int getNewHealth(){
		return newhealth;
	}
}
