package edu.rochester.cs.quagents3.client;

public class Shove extends ProtocolZero{
	private static final String opcode = "sv";
	
	private final double strength;
	private final double shove_yaw;
	private final double shove_pitch;
	
	public Shove(double strength, double shove_yaw, double shove_pitch, priority_t priority){
		super(false,CommandType.SHOVE,priority);
		this.strength=strength;
		this.shove_yaw = shove_yaw;
		this.shove_pitch = shove_pitch;
	}
	public Shove(double strength, double shove_yaw, double shove_pitch){
		super(false,CommandType.SHOVE);
		this.strength=strength;
		this.shove_yaw = shove_yaw;
		this.shove_pitch = shove_pitch;
	}
	public Shove(double strength, double shove_yaw, double shove_pitch, priority_t priority,long period){
		super(false,CommandType.SHOVE,period,priority);
		this.strength=strength;
		this.shove_yaw = shove_yaw;
		this.shove_pitch = shove_pitch;
	}
	public Shove(double strength, double shove_yaw, double shove_pitch,long period){
		super(false,CommandType.SHOVE,period);
		this.strength=strength;
		this.shove_yaw = shove_yaw;
		this.shove_pitch = shove_pitch;
	}
	public Shove(double strength, double shove_yaw, double shove_pitch, priority_t priority,long period,long delay){
		super(false,CommandType.SHOVE,period,delay,priority);	
		this.strength=strength;
		this.shove_yaw = shove_yaw;
		this.shove_pitch = shove_pitch;
	}
	public Shove(double strength, double shove_yaw, double shove_pitch,long period,long delay){
		super(false,CommandType.SHOVE,period,delay);	
		this.strength=strength;
		this.shove_yaw = shove_yaw;
		this.shove_pitch = shove_pitch;
	}

	protected void setOp(){
		op = Client.convertPriority(priority) + " "  + opcode + " " + id + " " + 
		strength + " " + shove_yaw + " "  + shove_pitch;
	}
	
	public void setData(String params) {
		System.err.println("error: Say does not facilitate data response");
	}
	
	/**
	 * Allows access to parameter data.
	 * @return Strength of shove.
	 */
	public double getStrength(){return strength;}
	
	/**
	 * Allows access to parameter data.
	 * @return Yaw of shove.
	 */
	public double getShoveYaw(){return shove_yaw;}
	
	/**
	 * Allows access to parameter data.
	 * @return Pitch of shove.
	 */
	public double getShovePitch(){return shove_pitch;}
}
