package edu.rochester.cs.quagents3.client;

/**
 * Class which represents a Skip CQM.
 */
public class Skip extends ProtocolZero{
	private static final String opcode = "sk";
	public Skip(priority_t priority){
		super(false,CommandType.SKIP,priority);
	}
	public Skip(){
		super(false,CommandType.SKIP);
	}
	public Skip(priority_t priority,long period){
		super(false,CommandType.SKIP,period,priority);
	}
	public Skip(long period){
		super(false,CommandType.SKIP,period);
	}
	public Skip(priority_t priority,long period,long delay){
		super(false,CommandType.SKIP,period,delay,priority);
	}
	public Skip(long period,long delay){
		super(false,CommandType.SKIP,period,delay);
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id;
	}
	
	public void setData(String params){
		System.err.println("error: Skip does not facilitate data response");
	}
}
