package edu.rochester.cs.quagents3.client;
import java.io.Writer;

/**
 * Class which represents a WhatIs query.
 */
public class WhatIs extends ProtocolZero{
	private static final String opcode = "wi";
	
	private final int entityid;
	private String entityclass;
	
	public WhatIs(int entityid, priority_t priority){
		super(true,CommandType.WHATIS,priority);
		this.entityid = entityid;
	}
	public WhatIs(int entityid){
		super(true,CommandType.WHATIS);
		this.entityid = entityid;
	}
	public WhatIs(int entityid, priority_t priority,long period){
		super(true,CommandType.WHATIS,period,priority);
		this.entityid = entityid;
	}
	public WhatIs(int entityid,long period){
		super(true,CommandType.WHATIS,period);
		this.entityid = entityid;
	}
	public WhatIs(int entityid, priority_t priority,long period,long delay){
		super(true,CommandType.WHATIS,period,delay,priority);
		this.entityid = entityid;
	}
	public WhatIs(int entityid,long period,long delay){
		super(true,CommandType.WHATIS,period,delay);
		this.entityid = entityid;
	}
	
	protected void setOp(){
		op = Client.convertPriority(priority) + " " + opcode + " " + id+
		" " + entityid;
	}
	
	/**
	 * Allows access to parameter data.
	 * @return Entity ID to classify.
	 */
	public int getEntityID(){return entityid;}

	/**
	 * Gets the class of the originally specified entity.
	 * @return Classtype corresponding to entityid.
	 */
	public String getEntityClass(){
		return entityclass;
	}
	
	public void setData(String params) {
		datastring = params;
		entityclass = params;
	}
}
