package edu.rochester.cs.quagents3.main;

import java.io.*;

import edu.rochester.cs.quagents3.client.CTFPlayer;

public class CaptureTheFlag extends Scenario{
	public static final String[] maps = {"randommap", "ctf_gate1", "maze1", "medroom", "delta"};
	private static final String scenarioname = "Capture the Flag";
	
	//more server config options, need to work these in somehow
	public String logfilename ="";
	public int lograte=-1;
	
	public CaptureTheFlag() {
		super(scenarioname,maps);
	}
	
	public void setGUI(){
		/*try {Quagents.next = new CTFPlayer("127.0.0.1", "ctflog");} 
		catch (IOException e) {e.printStackTrace();}
		Quagents.frame.setName("Quagents3 Capture the Flag");
		Quagents.frame.add(Quagents.next);
		Quagents.frame.remove(Quagents.init);
		Quagents.frame.pack();
		Quagents.frame.setVisible(true);*/
		Quagents.frame.setVisible(false);
	}
	
	protected void configure() throws IOException{
		File configfile = new File(System.getenv("HOME") + "/.quagents3/quagents3/quagents-config.cfg");
		if(!configfile.isFile())
			configfile.createNewFile();
		else{
			configfile.delete();
			configfile.createNewFile();
		}
		Writer config = new FileWriter(configfile);
		config.write("LOC_FLAG 1");
		config.flush();
		if(logfilename!=""){
			config.write("LOC_FILENAME " + logfilename);
			config.flush();
		}
		if(lograte!=-1){
			config.write("NUM_FRAMES_PER_LOG " + lograte);
			config.flush();
		}
	}

	//quagent is human controlled, no need to execute code
	//update: quagent is no longer needed, so we just exit client and
	//let server handle the rest.
	protected void runQuagentCode() {
		System.exit(NORM_PRIORITY);
	}
	protected void initialize(){}
}
