package edu.rochester.cs.quagents3.main;

import java.io.File;
import java.io.IOException;

import edu.rochester.cs.quagents3.client.Client;
import edu.rochester.cs.quagents3.client.QEvent;
import edu.rochester.cs.quagents3.client.QEventListener;
import edu.rochester.cs.quagents3.client.QuagentExecution;

public class CaveExploration extends Scenario{
	public static final String[] maps = {"randommap", "maze1","fan","largeroom"};
	private static final String scenarioname = "Cave Exploration";
	private CaveExplorer[] explorers; //team of quagent explorers
	private TrappedSurvivor[] survivors;
	
	public CaveExploration(int numexplorers, int numsurvivors){
		super(scenarioname,maps);
		explorers = new CaveExplorer[numexplorers];
		survivors = new TrappedSurvivor[numsurvivors];
	}

	
	protected void configure() throws IOException {
		File configfile = new File(System.getenv("HOME") + "/.quagents3/quagents3/quagents-config.cfg");
		if(!configfile.isFile())
			configfile.createNewFile();
		else{
			configfile.delete();
			configfile.createNewFile();
		}
	}

	protected void initialize() {
		for(int i=0; i<explorers.length; i++)
			explorers[i] = new CaveExplorer(i);
		for(int i=0; i<survivors.length; i++){
			if(randwidth > 0)
				survivors[i] = new TrappedSurvivor(i,randwidth,randheight);
			else
				survivors[i] = new TrappedSurvivor(i);
		}
	}

	protected void setGUI() {
		if(explorers.length==0){
			Quagents.frame.setVisible(false);
			return;
		}
		Quagents.next = new CaveExplorationGUI(explorers,survivors,director);
		Quagents.frame.setName("Quagents3 " + scenarioname);
		Quagents.frame.add(Quagents.next);
		Quagents.frame.remove(Quagents.init);
		Quagents.frame.pack();
		Quagents.frame.setVisible(true);
	}
	
	protected void runQuagentCode(){
		for(int i=0; i<explorers.length; i++)
			explorers[i].executeCode();
	}
}
