package edu.rochester.cs.quagents3.main;

import java.util.*;
import java.io.*;

import edu.rochester.cs.quagents3.client.Client;
import edu.rochester.cs.quagents3.client.priority_t;

public class Config {
	public static final String configfilename = "config.txt";
	public static String buildpath = "../../ioquake3/build/release-linux-i386/"; //build directory
	
	public static void config(){
		try{config(new BufferedReader(new FileReader(new File(configfilename))));}
		catch(Exception e1){e1.printStackTrace();}//System.out.println("No configuration file found. Proceeding...");}
	}
	
	private static void config(BufferedReader reader) throws IOException{
		String optn, nextline = ""; Scanner scan;
		nextline = reader.readLine();
		do{
			scan = new Scanner(nextline);
			optn = scan.next();
			
			//very important!!
			//this finds the executable
			if(optn.charAt(0)=='/'){
				buildpath = optn;
			}
			else if(optn.equals("DEFAULTSPEED")){
				try{Client.DEFAULTSPEED = scan.nextDouble();}
				catch(InputMismatchException e1){System.err.println("CONFIG ERROR: DEFAULTSPEED Token must be between 0 and 1");}
				catch(NoSuchElementException e2){System.err.println("CONFIG ERROR: Must provide a parameter"); e2.printStackTrace();}
			}
			else if(optn.equals("DEFAULTPRIORITY")){ //should we even let user modify this...?
				try{
					String temp = scan.next();
					if(temp.equals("NOW")){
						Client.DEFAULTPRIORITY = priority_t.NOW;
					}
					else if(temp.equals("REPLACE")){
						Client.DEFAULTPRIORITY = priority_t.REPLACE;
					}
					else if(temp.equals("LATER")){
						Client.DEFAULTPRIORITY = priority_t.LATER;
					}
					else
						System.err.println("CONFIG ERROR: DEFAULTPRIORITY must have a value of NOW, REPLACE or LATER");
				} catch(NoSuchElementException e2){System.err.println("CONFIG ERROR: Must provide a parameter"); e2.printStackTrace();}
			}
			else if(optn.equals("DEFAULT_RF_TYPE")){
				int type;
				try{type = scan.nextInt();}
				catch(InputMismatchException e1){System.err.println("CONFIG ERROR: DEFAULT_RF_TYPE Token must be an integer between 0 and 7 (inclusive)");
				continue;}
				catch(NoSuchElementException e2){System.err.println("CONFIG ERROR: Must provide a parameter"); e2.printStackTrace();
				continue;}
				if(type>=0 && type<=7)
					Client.DEFAULT_RF_TYPE = type;
				else
					System.err.println("CONFIG ERROR: DEFAULT_RF_TYPE Token must be an integer between 0 and 7 (inclusive)");
			}
			else if(optn.equals("DEFAULTVOLUME")){
				try{Client.DEFAULTVOLUME = scan.nextDouble();}
				catch(InputMismatchException e1){System.err.println("CONFIG ERROR: DEFAULTVOLUME Token must take the form of a decimal (floating point) number");}
				catch(NoSuchElementException e2){System.err.println("CONFIG ERROR: Must provide a parameter"); e2.printStackTrace();}
			}
			else if(optn.equals("VERBOSE")){
				String temp = scan.next();
				if(temp.equals("1") || temp.equals("T") || temp.equals("t") ||
						temp.equals("true") || temp.equals("True") || temp.equals("TRUE"))
					Client.VERBOSE = true;
				else if(temp.equals("0") || temp.equals("F") || temp.equals("f") || temp.equals("false")
						|| temp.equals("False") || temp.equals("FALSE"))
					Client.VERBOSE = false;
				else{
					System.err.println("CONFIG ERROR: Must provide a valid paramter"); new InputMismatchException().printStackTrace();
					continue;
				}
			}
			else if(optn.equals("SYNC") || optn.equals("SYNCHRNOOUS")){
				String temp = scan.next();
				if(temp.equals("1") || temp.equals("T") || temp.equals("t") ||
						temp.equals("true") || temp.equals("True") || temp.equals("TRUE"))
					Client.synchronous = true;
				else if(temp.equals("0") || temp.equals("F") || temp.equals("f") || temp.equals("false")
						|| temp.equals("False") || temp.equals("FALSE"))
					Client.synchronous = false;
				else{
					System.err.println("CONFIG ERROR: Must provide a valid paramter"); new InputMismatchException().printStackTrace();
					continue;
				}
			}
		}while((nextline = reader.readLine())!=null);
	}
}
