package edu.rochester.cs.quagents3.main;

import java.io.*;
import edu.rochester.cs.quagents3.util.StoppableThread;

public class Exec{
	private Process p;
	private Writer script;
	private String map;
	//private static final String serverpath = "../../ioquake3/build/release-linux-i386/ioquake3.i386";
	private static final String mapgenpath = "../auxquagents/MapGenerator/";
	private final String randmapname = "randmap";
	private boolean randommap = false;
	private File mapdir;
	private File map1;
	private File map2;
	
	public Exec(String map) {
		p=null;
		this.map = map;
	}

	//width and height in cells ("rooms")
	public Exec(int width, int height){
		p=null;
		mapdir = new File(Config.buildpath + "quagents3/maps/");
		GenerateRandomMap(width, height);
		map = randmapname;
		randommap = true;
	}
	
	private void GenerateRandomMap(int width, int height){
		System.out.println("Generating random map..."); System.out.flush();
		final int maxedges = width*4; //let's make this more mathematical...
		int complexity = (int)Math.floor(Math.random()*maxedges); //we'd rather have mazes that are harder to solve - i.e. fewer connections
		File f = new File(mapgenpath);
		if(!f.exists())
			f.mkdir();
		try{
		p=Runtime.getRuntime().exec("perl mazegen.pl " + randmapname + " " + width + " " + height + " " + complexity,null,f);
		p.waitFor();
		map1 = new File(mapgenpath + "maps/" + randmapname + ".aas");
		map2 = new File(mapgenpath + "maps/" + randmapname + ".bsp");
		map1.renameTo(new File(mapdir, map1.getName())); 
		map2.renameTo(new File(mapdir, map2.getName()));
		}
		catch(Exception e1){e1.printStackTrace();}
		System.out.println("Random map generated!"); System.out.flush();
	}
	
	public void run(){
		try{GameStarter.StartGame();}
		catch(Exception e1){System.err.println("****** Critical error: cannot locate Quagents3 server ******"); System.exit(-1);}
		//TODO: figure out how to script to follow bot
		/*
		script = new OutputStreamWriter(p.getOutputStream());
		try{script.write("^C"); script.flush();}
		catch(Exception e1){System.err.println("script error at: "); e1.printStackTrace();}
		*/
	}
}
