package edu.rochester.cs.quagents3.main;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import edu.rochester.cs.quagents3.client.QuagentExecution;

public class Sandbox extends Scenario{
public static final String[] maps = {"randommap", "delta","firstroom", "hurdles", "largeroom",
	"medroom", "smallroom", "maze1"};
private static final String scenarioname = "Sandbox";
private QuagentExecution quagentcode;

	public Sandbox(){
		super(scenarioname,maps);
	}
	
	//simply make blank config file so server configs to default settings
	protected void configure() throws IOException{
		File configfile = new File(System.getenv("HOME") + "/.quagents3/quagents3/quagents-config.cfg");
		if(!configfile.isFile())
			configfile.createNewFile();
		else{
			configfile.delete();
			configfile.createNewFile();
		}
		Writer config = new FileWriter(configfile);
		config.write("LOC_FLAG 1");
		config.flush();
	}
	
	protected void initialize(){
		quagentcode = new QuagentsSandbox();
	}
	
	protected void runQuagentCode(){
		quagentcode.executeCode();
	}


	protected void setGUI() {
	}
}
