package edu.rochester.cs.quagents3.main;

public class ScenarioStarter {
	public static void main(String args[]){
		String scenariotype = "";
		try{scenariotype = args[0];}
		catch(Exception e1){usage(); System.exit(-1);}
		if(scenariotype.equals("Sandbox"))
			new Sandbox().executeBody(args[1]);
		else if(scenariotype.equals("CaptureTheFlag"))
			new CaptureTheFlag().executeBody(args[1]);
		else if(scenariotype.equals("CaveExploration"))
			new CaveExploration(2,0).executeBody(args[1]); //we need to make the # of explorers and survivors variable, take cmd line arg?
		else if(scenariotype.equals("WumpusWorld"))
			new WumpusWorld().executeBody(args[1]);
		else if(scenariotype.equals("DirectorControl"))
			new DirectorControl().executeBody(args[1]);
		else if(scenariotype.equals("RoboticImagingSystem"))
			new RoboticImagingSystem().executeBody(args[1]);
		else{
			usage(); System.exit(-1);
		}
	}
	
	public static void usage(){
		System.out.println("-----------------------------------------");
		System.out.println("Usage:");
		System.out.println("java -jar <JARNAME> [scenariotype] [map]");
		
		System.out.print("valid scenariotypes:\t");
		System.out.println("Sandbox\tCaptureTheFlag\tCaveExploration\tWumpusWorld\tDirectorControl\tRoboticImagingSystem");
		
		System.out.println("valid maps:");
		
		System.out.print("Sandbox:\t\t");
		for(int i=0; i<Sandbox.maps.length; i++)
			System.out.print(Sandbox.maps[i] + "\t");
		System.out.println();
		
		System.out.print("CaptureTheFlag:\t\t");
		for(int i=0; i<CaptureTheFlag.maps.length; i++)
			System.out.print(CaptureTheFlag.maps[i] + "\t");
		System.out.println();
		
		System.out.print("CaveExploration:\t");
		for(int i=0; i<CaveExploration.maps.length; i++)
			System.out.print(CaveExploration.maps[i] + "\t");
		System.out.println();
		
		System.out.print("WumpusWorld:\t\t");
		for(int i=0; i<WumpusWorld.maps.length; i++)
			System.out.print(WumpusWorld.maps[i] + "\t");
		System.out.println();
		
		System.out.print("DirectorControl:\t");
		for(int i=0; i<DirectorControl.maps.length; i++)
			System.out.print(DirectorControl.maps[i] + "\t");
		System.out.println();
		
		System.out.print("RoboticImagingSystem:\t");
		for(int i=0; i<RoboticImagingSystem.maps.length; i++)
			System.out.print(RoboticImagingSystem.maps[i] + "\t");
		System.out.println();
		
		System.out.println("-----------------------------------------");
	}
}
