package edu.rochester.cs.quagents3.main;

import edu.rochester.cs.quagents3.client.*;

public class TrappedSurvivor implements QuagentExecution{
	private double[] location;
	private Client survivor;
	public final int id;
	private static final int SURVIVORVOLUME = 8000;
	private static final int SURVIVORHELPPERIOD = 5000;
	private Say callforhelp;
	
	//maze - 128
	//wumpus - 256
	public TrappedSurvivor(int id){
		this.id = id;
		callforhelp = new Say(SURVIVORVOLUME, "Help me!", SURVIVORHELPPERIOD);
		getLocation();
		try{
		survivor = new Client("127.0.0.1");
		survivor.initialPosition(location[0], location[1], location[2]);
		survivor.name("Survivor");
		survivor.ready();
		}
		catch(Exception e1){e1.printStackTrace();}
		survivor.start(callforhelp);
	}
	
	public TrappedSurvivor(int id, int width, int height){
		this.id = id;
		callforhelp = new Say(SURVIVORVOLUME, "Help me!", SURVIVORHELPPERIOD);
		getLocation(width,height);
		try{
		survivor = new Client("127.0.0.1");
		survivor.addEventListener(new QEventListener(){public void hasDied(QEvent event){}public void messageHeard(QEvent event){}});
		survivor.initialPosition(location[0], location[1], location[2]);
		survivor.name("Survivor");
		survivor.ready();
		}
		catch(Exception e1){e1.printStackTrace();}
		survivor.start(callforhelp);
	}
	
	private void getLocation(int width, int height){
		location = new double[3];
		location[2] = 0;
		location[0] = 128/2 * Math.ceil(Math.random()*width);
		location[1] = 128/2 * Math.ceil(Math.random()*height);
		System.out.println("x: " + location[0] +"\tu: " + location[1]);
	}
	
	private void getLocation(){
		location = new double[3];
	}

	public String getSurvivorName(){
		return survivor.name;
	}
	
	public void executeCode() {
		survivor.start(callforhelp);
	}
}
