package edu.rochester.cs.quagents3.main;

import java.io.File;
import java.io.IOException;

import edu.rochester.cs.quagents3.client.WumpusSolver;

public class WumpusWorld extends Scenario{
	public static final String[] maps = {"Wumpus2","WumpusWorld"};
	private static final String scenarioname = "Wumpus World";
	private WumpusSolver agent;
	
	public WumpusWorld(){
		super(scenarioname, maps);
	}
	
	//don't need to config server, so we erase config file
	protected void configure() throws IOException{
		File configfile = new File(System.getenv("HOME") + "/.quagents3/quagents3/quagents-config.cfg");
		if(!configfile.isFile())
			configfile.createNewFile();
		else{
			configfile.delete();
			configfile.createNewFile();
		}
	}
	
	protected void initialize(){
		if(selectedmap.equals("Wumpus2")){
			agent = new WumpusSolver(4,4,director);
		}
		else if(selectedmap.equals("WumpusWorld")){
			agent = new WumpusSolver(5,5,director);
		}
	}
	
	protected void setGUI() {
		Quagents.next = agent.gui;
		Quagents.frame.setName("Quagents 3 " + scenarioname);
		Quagents.frame.add(Quagents.next);
		Quagents.frame.remove(Quagents.init);
		Quagents.frame.pack();
		Quagents.frame.setVisible(true);
	}
	
	protected void runQuagentCode(){
		agent.executeCode();
	}

}
